std::is_unbounded_array(3)

NAME
std::is_unbounded_array - std::is_unbounded_array

Synopsis
   Defined in header <type_traits>
   template< class T > (since C++20)
   struct is_unbounded_array;
   std::is_unbounded_array is a UnaryTypeTrait.
   Checks whether T is an arrays of unknown bound. Provides the member constant value
   which is equal to true, if T is an array type of unknown bound. Otherwise, value is
   equal to false.
   If the program adds specializations for std::is_unbounded_array or
   std::is_unbounded_array_v, the behavior is undefined.

Template parameters
   T - a type to check
   Helper variable template
   template< class T >
   inline constexpr bool is_unbounded_array_v = (since C++20)
   is_unbounded_array<T>::value; Inherited from std::integral_constant

Member constants
   value true if T is an array type of unknown bound., false otherwise
   [static] (public static member constant)

Member functions
   operator bool converts the object to bool, returns value
                 (public member function)
   operator() returns value
   (C++14) (public member function)

Member types
   Type Definition
   value_type bool
   type std::integral_constant<bool, value>

Possible implementation
   template<class T>
   struct is_unbounded_array: std::false_type {};
   template<class T>
   struct is_unbounded_array<T[]> : std::true_type {};

Notes
         Feature-test macro Value Std Feature
   __cpp_lib_bounded_array_traits 201902L (C++20) std::is_bounded_array,
                        std::is_unbounded_array

Example
// Run this code
 #include <type_traits>
 class A {};
 static_assert
 (""
     && std::is_unbounded_array_v<A> == false
     && std::is_unbounded_array_v<A[]> == true
     && std::is_unbounded_array_v<A[3]> == false
     && std::is_unbounded_array_v<float> == false
     && std::is_unbounded_array_v<int> == false
     && std::is_unbounded_array_v<int[]> == true
     && std::is_unbounded_array_v<int[3]> == false
 );
 int main() {}

See also
   is_array checks if a type is an array type
   (C++11) (class template)
   is_bounded_array checks if a type is an array type of known bound
   (C++20) (class template)
   extent obtains the size of an array type along a specified dimension
   (C++11) (class template)